#include <limits.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <curl/curl.h>
#include <stdio.h>
#include <wchar.h>
#include "fmt.h"
#include "tags.h"
/*#include "queue.h"*/
#include "listento.h"
#include "config.h"

#define LISTENTO_URL "http://magic.listen-to.com"
#define LISTENTO_CLI_ID "ListenTo_xmms"

static int	lt_errors;

static char	lt_curl_errbuf[CURL_ERROR_SIZE],
		*lt_username,
		*lt_password;
/*#define SCROBBLER_HS_WAIT 1800

 * Scrobblerbackend for xmms plugin, first draft *

static int	sc_hs_status,
		sc_hs_timeout,
		sc_errors,
		sc_submit_interval,
		sc_submit_timeout,
		sc_srv_res_size,
		sc_giveup;

static char 	*sc_submit_url,
		*sc_username,
		*sc_password,
		*sc_srv_res,
		sc_curl_errbuf[CURL_ERROR_SIZE];


static size_t sc_store_res(void *ptr, size_t size,
		size_t nmemb,
		void *stream)
{
	int len = size * nmemb;

	sc_srv_res = realloc(sc_srv_res,
			sc_srv_res_size + len);
	memcpy(sc_srv_res + sc_srv_res_size,
			ptr, len);
	sc_srv_res_size += len;
	return len;
}

static void sc_free_res(void)
{
	free(sc_srv_res);
	sc_srv_res = NULL;
	sc_srv_res_size = 0;
}

static int sc_parse_hs_res(void)
{
	char *interval;

	if (!sc_srv_res_size) {
		pdebug("No reply from server");
		return -1;
	}
	*(sc_srv_res + sc_srv_res_size - 1) = 0;

	if (!strncmp(sc_srv_res, "FAILED", 7)) {
		pdebug(fmt_vastr("error: %s", sc_srv_res));
		return -1;
	}
	if (!strncmp(sc_srv_res, "UPTODATE ", 9)) {
		pdebug(fmt_vastr("update client: %s", sc_srv_res + 9));
		sc_giveup = -1;
		return -1;
	}
	if (!strncmp(sc_srv_res, "UPTODATE\n", 9)) {
		interval = strstr(sc_srv_res, "INTERVAL");
		if (!interval) {
			pdebug("missing INTERVAL");
			return -1;
		}
		*(interval - 1) = 0;
		sc_submit_url = strdup(sc_srv_res + 9);
		sc_submit_interval = strtol(interval + 8, NULL, 10);
		return 0;
	}
	pdebug(fmt_vastr("unkown server-reply '%s'", sc_srv_res));
	return -1;
}

static int sc_handshake(void)
{
	int status;
	char buf[4096];
	CURL *curl;
	
	snprintf(buf, sizeof(buf), "%s/?hs=true&v=%s&c=%s",
			SCROBBLER_HS_URL, VERSION, SCROBBLER_CLI_ID);
	curl = curl_easy_init();
	curl_easy_setopt(curl, CURLOPT_NOPROGRESS, 1);
	curl_easy_setopt(curl, CURLOPT_URL, buf);
	curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, 
			sc_store_res);
	memset(sc_curl_errbuf, 0, sizeof(sc_curl_errbuf));
	curl_easy_setopt(curl, CURLOPT_ERRORBUFFER, sc_curl_errbuf);
	status = curl_easy_perform(curl);
	curl_easy_cleanup(curl);
	sc_hs_timeout = time(NULL) + SCROBBLER_HS_WAIT;
	if (status) {
		pdebug(sc_curl_errbuf);
		sc_errors++;
		sc_free_res();
		return -1;
	} 
	if (sc_parse_hs_res()) {
		sc_errors++;
		sc_free_res();
		return -1;
	}
	sc_errors = 0;
	sc_hs_status = 1;
	sc_free_res();
	pdebug(fmt_vastr("submiturl: %s - interval: %d", 
				sc_submit_url, sc_submit_interval));
	return 0;
}

static int sc_parse_sb_res(void)
{
	char *ch;
#ifdef ALLOW_MULTIPLE
	int i;
#endif

	if (!sc_srv_res_size) {
		pdebug("No response from server");
		return -1;
	}
	*(sc_srv_res + sc_srv_res_size - 1) = 0;
	if (!strncmp(sc_srv_res, "OK", 2)) {
#ifdef ALLOW_MULTIPLE
		q_free();
#else
		q_pop();
#endif
		if ((ch = strstr(sc_srv_res, "INTERVAL"))) {
			sc_submit_interval = strtol(ch + 8, NULL, 10);
			pdebug(fmt_vastr("got new interval: %d",
						sc_submit_interval));
		}
		pdebug(fmt_vastr("submission ok: %s", sc_srv_res));
		return 0;
	}
	if (!strncmp(sc_srv_res, "BADPASS", 7)) {
		pdebug("incorrect username/password");
		sc_giveup = 1;
		return -1;
	}
	if (!strncmp(sc_srv_res, "FAILED", 6))  {
		pdebug(sc_srv_res);
		sc_errors++;
		return -1;
	}
	pdebug(fmt_vastr("unknown server-reply %s", sc_srv_res));
	return -1;
}

static char *sc_itemtag(char c, int n)
{
	static char buf[128];
	snprintf(buf, sizeof(buf), "%c[%d]", c, n);
	return buf;
}*/

char *adjust_spaces(char *tmp)
{
	char *i, *ret;
	int j;
	for(i = tmp; i < tmp + strlen(tmp); i++)
	{
		if(*i == ' ')
		{
			j = i - tmp;
			ret = malloc(strlen(tmp) + 1);
			memcpy(ret, tmp, strlen(tmp) + 1);
			free(tmp);
			tmp = malloc(strlen(ret) + 3);
			memcpy(tmp, ret, strlen(ret) + 1);
			free(ret);
			i = tmp + j;
			memmove(i + 3, i + 1, strlen(i + 1) + 1);
			*i++ = '%';
			*i++ = '2';
			*i = '0';
		}
	}
	return tmp;
}

#define cfa(f, l, n, v) \
curl_formadd(f, l, CURLFORM_COPYNAME, n, \
		CURLFORM_PTRCONTENTS, v, CURLFORM_END)
int lt_submitentry(metadata meta)
{
	CURL *curl;
	/*struct HttpPost *post = NULL, *last = NULL;*/
	int status;
	char lt_submit_url[4096] = "", *artist, *album, *title, *genre = NULL, *year = NULL, *length, tmp[256] = "";

	artist = malloc(wcslen(meta.artist) + 1);
	memset(artist, '\0', wcslen(meta.artist) + 1);
	wcstombs(artist, meta.artist, wcslen(meta.artist));
	artist = adjust_spaces(artist);
	album = malloc(wcslen(meta.album) + 1);
	memset(album, '\0', wcslen(meta.album) + 1);
	wcstombs(album, meta.album, wcslen(meta.album));
	album = adjust_spaces(album);
	title = malloc(wcslen(meta.title) + 1);
	memset(title, '\0', wcslen(meta.title) + 1);
	wcstombs(title, meta.title, wcslen(meta.title));
	title = adjust_spaces(title);
	if(meta.genre != NULL)
	{
		genre = malloc(wcslen(meta.genre) + 1);
		memset(genre, '\0', wcslen(meta.genre) + 1);
		wcstombs(genre, meta.genre, wcslen(meta.genre));
		genre = adjust_spaces(genre);
	}
	if(meta.year != NULL)
	{
		year = malloc(wcslen(meta.year) + 1);
		memset(year, '\0', wcslen(meta.year) + 1);
		wcstombs(year, meta.year, wcslen(meta.year));
		year = adjust_spaces(year);
	}
	length = malloc(21);
	memset(length, '\0', 21);
	snprintf(length, 20, "%d", meta.length);

	snprintf(lt_submit_url, sizeof(lt_submit_url), "%s/postmp3.php?USER=%s&PASS=%s&ARTIST=%s&ALBUM=%s&TITLE=%s&LENGTH=%d", LISTENTO_URL, lt_username, lt_password, artist, album, title, meta.length);
	if(meta.genre != NULL)
	{
		snprintf(tmp, sizeof(tmp), "&GENRE=%s", genre);
		strncat(lt_submit_url, tmp, sizeof(lt_submit_url) - strlen(tmp));
	}
	if(meta.year != NULL)
	{
		snprintf(tmp, sizeof(tmp), "&YEAR=%s", year);
		strncat(lt_submit_url, tmp, sizeof(lt_submit_url) - strlen(tmp));
	}
	pdebug(lt_submit_url);

	curl = curl_easy_init();
	curl_easy_setopt(curl, CURLOPT_NOPROGRESS, 1);
	curl_easy_setopt(curl, CURLOPT_URL, lt_submit_url);
	curl_easy_setopt(curl, CURLOPT_USERAGENT, LISTENTO_CLI_ID);
	/*cfa(&post, &last, "USER", lt_username);
	cfa(&post, &last, "PASS", lt_password);
	i = 0;*/
#ifdef ALLOW_MULTIPLE
	/*q_peekall(1);
	while ((item = q_peekall(0))) {
#else
		item = q_peek();*/
#endif
		/*cfa(&post, &last, "ARTIST", artist);
		cfa(&post, &last, "ALBUM", album);
		cfa(&post, &last, "TITLE", title);
		if(meta.genre != NULL) cfa(&post, &last, "GENRE", genre);
		if(meta.year != NULL) cfa(&post, &last, "YEAR", year);
		cfa(&post, &last, "LENGTH", meta.length);*/
		pdebug(fmt_vastr("ARTIST=%s ALBUM=%s TITLE=%s GENRE=%s YEAR=%s LENGTH=%s",
				artist,
				album,
				title,
				genre,
				year,
				length));
#ifdef ALLOW_MULTIPLE
/*		i++;
	}*/
#endif
	/* curl_easy_setopt(curl, CURLOPT_HTTPGET, post); */
	memset(lt_curl_errbuf, 0, sizeof(lt_curl_errbuf));
	curl_easy_setopt(curl, CURLOPT_ERRORBUFFER, lt_curl_errbuf);
	status = curl_easy_perform(curl);
	/*curl_formfree(post);*/
	curl_easy_cleanup(curl);

	free(artist);
	free(album);
	free(title);
	if(meta.genre != NULL) free(genre);
	if(meta.year != NULL) free(year);
	free(length);

	if (status) {
		pdebug(lt_curl_errbuf);
		lt_errors++;
		/*sc_free_res();*/
		return -1;
	}
	/*if (sc_parse_sb_res()) {
		sc_errors++;
		sc_free_res();
		pdebug(fmt_vastr("Retrying in %d secs, %d elements in queue",
					sc_submit_interval, q_len()));
		return -1;
	}
	sc_free_res();*/
	return 0;
}

/*static void sc_handlequeue(void)
{
	if (!q_len())
		return;
	if (sc_submit_timeout < time(NULL)) {
		sc_submitentry();
		sc_submit_timeout = time(NULL) +
			sc_submit_interval;
	}
}

static void dump_queue(void)
{
	FILE *fd;
	item_t *item;
	char *home, buf[PATH_MAX];

	if (!(home = getenv("HOME")))
		return;

	snprintf(buf, sizeof(buf), "%s/.xmms/scrobblerqueue.txt", home);
	if (!(fd = fopen(buf, "w")))
		return;
	printf("Opening %s\n", buf);
	q_peekall(1);
	while ((item = q_peekall(0))) {
		fprintf(fd, "%s %s %s %s %s %s\n",
					I_ARTIST(item),
					I_TITLE(item),
					I_LEN(item),
					I_TIME(item),
					I_ALBUM(item),
					I_MB(item));
	}
	fclose(fd);
}*/

static void lt_cleaner(void)
{
	free(lt_username);
	/* free(sc_srv_res);
	dump_queue();
	q_free();*/
	pdebug("listen-to shutting down");
}

/*static void sc_checkhandshake(void)
{
	if (sc_errors > 2)
		sc_hs_status = 0;
	if (sc_hs_status)
		return;
	if (sc_errors > 2) {
		if (sc_hs_timeout < time(NULL))
			sc_handshake();
		return;
	}
	sc_handshake();
}

 **** Public *****

 * Called at session startup*/

void lt_init(char *uname, char *pwd)
{
	lt_username = strdup(uname);
	lt_password = strdup(pwd);
	atexit(lt_cleaner);
	pdebug("listen-to starting up");
}

/*void sc_addentry(metadata meta, int len)
{
	q_push(meta, len);
}

 * Call periodically from the plugin */
int lt_idle(void)
{
	/*sc_checkhandshake();
	if (sc_hs_status)
		sc_handlequeue();
	return sc_giveup;*/
	return 0;
}
